/*
 * QLogic iSCSI HBA Driver
 * Copyright (c)  2003-2011 QLogic Corporation
 *
 * See LICENSE.qla4xxx for copyright and licensing details.
 */

/* Defines for interim workaround code */

#if 0
#define ql4_printk(level, ha, format, arg...) 				\
	printk( "%s(%ld): %s: " format , 				\
		dev_driver_string(&((ha)->pdev->dev)), 			\
		(ha)->host_no, dev_name(&((ha)->pdev->dev)), ## arg)
#else
#define ql4_printk(level, ha, format, arg...) \
	dev_printk(level , &((ha)->pdev->dev) , format , ## arg)
#endif

#define ql4_info(ha, format, arg...)  	\
	ql4_printk(KERN_INFO, ha, format, ## arg)
#define ql4_warn(ha, format, arg...)  	\
	ql4_printk(KERN_WARNING, ha, format, ## arg)
#define ql4_err(ha, format, arg...)  	\
	ql4_printk(KERN_ERR, ha, format, ## arg)
#define ql4_dbg(ha, format, arg...)  	\
	ql4_printk(KERN_DEBUG, ha, format, ## arg)
/*
 * Driver debug definitions.
 */
/* #define QL_DEBUG  */			/* DEBUG messages */
/* #define QL_DEBUG_LEVEL_3  */		/* Output function tracing */
/* #define QL_DEBUG_LEVEL_4  */
/* #define QL_DEBUG_LEVEL_5  */
/* #define QL_DEBUG_LEVEL_9  */

#define QL_DEBUG_LEVEL_2	/* ALways enable error messagess */
#define QL_DEBUG_LEVEL_6	/* ALways enable iSNS error messagess */
#define QL_DEBUG_LEVEL_7	/* Detailed Initialization */
#define QL_DEBUG_LEVEL_13 	/* Enable minidump collect log */
#if defined(QL_DEBUG)
#define DEBUG(x)   do {x;} while (0);
#else
#define DEBUG(x)	do {} while (0);
#endif

#if defined(QL_DEBUG_LEVEL_2)
#define DEBUG2(x)      do {if(ql4xextended_error_logging == 2) x;} while (0);
#define DEBUG2_3(x)   do {x;} while (0);
#else				/*  */
#define DEBUG2(x)	do {} while (0);
#endif				/*  */

#if defined(QL_DEBUG_LEVEL_3)
#define DEBUG3(x)      do {if(ql4xextended_error_logging == 3) x;} while (0);
#else				/*  */
#define DEBUG3(x)	do {} while (0);
#if !defined(QL_DEBUG_LEVEL_2)
#define DEBUG2_3(x)	do {} while (0);
#endif				/*  */
#endif				/*  */
#if defined(QL_DEBUG_LEVEL_4)
#define DEBUG4(x)	do {x;} while (0);
#else				/*  */
#define DEBUG4(x)	do {} while (0);
#endif				/*  */

#if defined(QL_DEBUG_LEVEL_5)
#define DEBUG5(x)	do {x;} while (0);
#else				/*  */
#define DEBUG5(x)	do {} while (0);
#endif				/*  */

#if defined(QL_DEBUG_LEVEL_6)
#define DEBUG6(x)      do {if(ql4xextended_error_logging & 0x20) x;} while (0);
#else
#define DEBUG6(x)
#endif

#if defined(QL_DEBUG_LEVEL_7)
#define DEBUG7(x)      do {if(ql4xextended_error_logging & 0x40) x;} while (0);
#else
#define DEBUG7(x)
#endif

#if defined(QL_DEBUG_LEVEL_9)
#define DEBUG9(x)	do {x;} while (0);
#else				/*  */
#define DEBUG9(x)	do {} while (0);
#endif				/*  */

#if defined(QL_DEBUG_LEVEL_13)
#define DEBUG13(x)      do {if(ql4xextended_error_logging & 0x1000) x;} while (0);
#else
#define DEBUG13(x)
#endif
